<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <!-- Thêm nút thêm đơn hàng  -->
        <button class="btn btn-success m-2" onclick="onBtnCreateOrderClick()">Thêm đơn hàng</button>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                    <th scope="col">Delete</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_CREATE_SUCCESS = 201; // tạo thành công
        const gREQUEST_DELETE_SUCCESS = 204; // xóa thành công
        const gEND_OF_TABLE_ROW = -1;
        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_NUOC_UONG = 3;
        const gCOLUMN_THANH_TIEN = 4;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_SDT = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_ACTION = 8;
        const gCOLUM_DELETE = 9;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        function deleteOrder(orderId) {
            var deleteUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders/" + orderId;
            var vXmlHttpDeleteOrders = new XMLHttpRequest();
            vXmlHttpDeleteOrders.open("DELETE", deleteUrl, true);
            vXmlHttpDeleteOrders.onreadystatechange = function () {
                if (vXmlHttpDeleteOrders.readyState === gREQUEST_READY_STATUS_FINISH_AND_OK) {
                    if (vXmlHttpDeleteOrders.status === gREQUEST_DELETE_SUCCESS) {
                        alert("Xóa đơn hàng thành công!");
                        location.reload(); // Tải lại trang danh sách đơn hàng
                    } else {
                        alert("Xóa đơn hàng không thành công!");
                    }
                }
            };
            vXmlHttpDeleteOrders.send();
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            };
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã được trả lời
        // ouptut/end: dữ liệu hiển thị trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            // CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vPerson = JSON.parse(paramXMLHttpAllOrder.responseText);
            var vTable = document.getElementById("table-order");
            var vTbody = document.getElementsByTagName("tbody")[0];
            for (var bI = 0; bI < vPerson.length; bI++) {
                var bRowBody = vTbody.insertRow(gEND_OF_TABLE_ROW);
                var bCellOrder = bRowBody.insertCell(gCOLUMN_ORDER_CODE);
                var bCellKichCo = bRowBody.insertCell(gCOLUMN_KICH_CO);
                var bCellLoaiPizza = bRowBody.insertCell(gCOLUMN_LOAI_PIZZA);
                var bCellNuocUong = bRowBody.insertCell(gCOLUMN_NUOC_UONG);
                var bCellTien = bRowBody.insertCell(gCOLUMN_THANH_TIEN);
                var bCellHoTen = bRowBody.insertCell(gCOLUMN_HO_TEN);
                var bCellSoDT = bRowBody.insertCell(gCOLUMN_SDT);
                var bCellStatus = bRowBody.insertCell(gCOLUMN_TRANG_THAI);
                var bCellAction = bRowBody.insertCell(gCOLUMN_ACTION);
                var bCellDelete = bRowBody.insertCell(gCOLUM_DELETE);
                bCellOrder.innerHTML = vPerson[bI].orderCode;
                bCellKichCo.innerHTML = vPerson[bI].kichCo;
                bCellLoaiPizza.innerHTML = vPerson[bI].loaiPizza;
                bCellNuocUong.innerHTML = vPerson[bI].idLoaiNuocUong;
                bCellTien.innerHTML = vPerson[bI].thanhTien;
                bCellHoTen.innerHTML = vPerson[bI].hoTen;
                bCellSoDT.innerHTML = vPerson[bI].soDienThoai;
                bCellStatus.innerHTML = vPerson[bI].trangThai;

                var vButton = document.createElement("button");
                vButton.className = "btn btn-info";
                vButton.innerHTML = "Chi tiết";
                vButton.setAttribute("data-id", vPerson[bI].id);
                vButton.setAttribute("data-orderCode", vPerson[bI].orderCode);

                bCellAction.appendChild(vButton);

                vButton.addEventListener("click", function () {
                    onBtnDetailClick(this);
                });

                var vDeleteButton = document.createElement("button");
                vDeleteButton.className = "btn btn-danger";
                vDeleteButton.innerHTML = "Delete";
                vDeleteButton.setAttribute("data-id", vPerson[bI].id);
                vDeleteButton.addEventListener("click", function () {
                    onDeleteButtonClick(this);
                });

                bCellDelete.appendChild(vDeleteButton);
            }
        }

        function onBtnDetailClick(paramOrderDetail) {
            var vId = paramOrderDetail.dataset.id;
            var vOrder = paramOrderDetail.dataset.ordercode;
            console.log("ID: " + vId);
            console.log("Order code: " + vOrder);

            const gDETAIL = "order-detail.html";
            var vOpenUrl = gDETAIL + "?id=" + vId + "&orderCode=" + vOrder;
            window.location.href = vOpenUrl;
        }

        function onDeleteButtonClick(button) {
            var orderId = button.dataset.id;
            var confirmation = confirm("Bạn có chắc chắn muốn xóa đơn hàng này không?");
            if (confirmation) {
                deleteOrder(orderId);
            }
        }

        //Hàm xử lý khi nút Thêm đơn hàng được click
        function onBtnCreateOrderClick() {
            "use strict";
            const vCREATE_ORDER_FORM_URL = "create.order.html";
            var vUrlSiteToOpen = vCREATE_ORDER_FORM_URL
            window.location.href = vUrlSiteToOpen;
        }
    </script>